@Echo off

REM pdf oder tif
set fileType=pdf

REM Pfad zum Programm IrfanView
set progIrfanView=C:\Programme\IrfanView\i_view32.exe



REM Das muss nicht angepasst werden
if exist "%progIrfanView%" goto GETTEMPPATH

REM Erkennung unter Windows VISTA
if not errorlevel 0 goto IRFANVIEWXP

REM Automatische Pfaderkennung von IrfanView falls Pfad nicht stimmt
FOR /F "skip=2 usebackq tokens=2*" %%i IN (`reg query "HKCR\Applications\i_view32.exe\shell\open\command" /ve`) DO set progIrfanView=%%j

REM Alle " entfernen mit der Ersetzenfunktion
set progIrfanView=%progIrfanView:"=%

REM " %1" entfernen
set progIrfanView=%progIrfanView:~0,-3%

if exist "%progIrfanView%" goto GETTEMPPATH

REM Erkennung unter Windows XP
:IRFANVIEWXP
if not errorlevel 0 goto IRFANVIEWNOTFOUND

REM Automatische Pfaderkennung von IrfanView falls Pfad nicht stimmt
FOR /F "skip=4 usebackq tokens=3*" %%i IN (`reg query "HKCR\Applications\i_view32.exe\shell\open\command" /ve`) DO set progIrfanView=%%j

REM Alle " entfernen mit der Ersetzenfunktion
set progIrfanView=%progIrfanView:"=%

REM " %1" entfernen
set progIrfanView=%progIrfanView:~0,-3%

if not exist "%progIrfanView%" goto IRFANVIEWNOTFOUND


:GETTEMPPATH

if not "%TMP%"=="" set tmpPath=%TMP%
if not "%TEMP%"=="" set tmpPath=%TEMP%
if "%tmpPath%"=="" set tmpPath=C:\temp

set scanFileName=scanfile
set outputFileName=%1

if "%outputFileName%"=="" set outputFileName=%tmpPath%\dorisscan.%fileType%

if exist "%outputFileName%" del "%outputFileName%"

if %fileType%==pdf goto PDF
if %fileType%==tif goto TIF
if %fileType%==tiff goto TIF

echo "Es wurde ein falscher fileType angegeben !"

exit


:TIF
if exist "%tmpPath%\%scanFileName%*.tif" del "%tmpPath%\%scanFileName%*.tif"

"%progIrfanView%" /batchscan=("%scanFileName%",1,1,2,0,"%tmpPath%",tif,1)

if not exist "%tmpPath%\%scanFileName%*.tif" exit

if "%1"=="" ( 
echo %tmpPath%\%scanFileName%01.tif  
) else (
copy "%tmpPath%\%scanFileName%01.tif" "%outputFileName%"
del "%tmpPath%\%scanFileName%*.tif"
)
exit


:PDF
if exist "%tmpPath%\%scanFileName%*.tif" del "%tmpPath%\%scanFileName%*.tif"

"%progIrfanView%" /batchscan=("%scanFileName%",1,1,2,0,"%tmpPath%",tif,1)

if not exist "%tmpPath%\%scanFileName%*.tif" exit

REM convert mit IrfanView
"%progIrfanView%" "%tmpPath%\%scanFileName%01.tif" /convert=%outputFileName% > "%tmpPath%\dorisscan.log"

del "%tmpPath%\%scanFileName%*.tif"
if "%1"=="" echo %outputFileName%
exit


:IRFANVIEWNOTFOUND
echo Das Programm IrfanView wurde unter dem Pfad "%progIrfanView%" nicht gefunden! Bitte geben Sie den Pfad in dieser Datei "DoRISScan.cmd" vollstaendig ein.
exit